﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Infragistics.Win.UltraWinGrid;
using Infragistics.Win;
using Infragistics.Win.FormattedLinkLabel;
using System.Drawing;

namespace UltraGridWithComboAutoSuggest
{
    public class UltraComboEx : UltraCombo
    {
        public UltraComboEx()
        {
            this.InitializeLayout += new InitializeLayoutEventHandler(UltraComboEx_InitializeLayout);
            this.CreationFilter = new SearchCreation();
        }

        void UltraComboEx_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            e.Layout.Bands[0].Override.ActiveRowAppearance.ForeColor = Color.Black;
            foreach (UltraGridColumn col in e.Layout.Bands[0].Columns)
            {
                col.Style = ColumnStyle.FormattedTextEditor;
            }
        }

        protected override bool OnActiveRowChange(UltraGridRow newActiveRow, bool scrollIntoView)
        {
            SearchCreation.SearchText = this.Text;
            return base.OnActiveRowChange(newActiveRow, scrollIntoView);
        }

        protected override void OnTextChanged(EventArgs e)
        {
            base.OnTextChanged(e);
            SearchCreation.SearchText = this.Text;
        }
    }

    class SearchCreation : IUIElementCreationFilter
    {
        public static string SearchText;

        public void AfterCreateChildElements(UIElement parent) { }

        public bool BeforeCreateChildElements(UIElement parent)
        {
            FormattedTextUIElement textElement = parent as FormattedTextUIElement;
            if (textElement != null && SearchText != null)
            {
                if (SearchText.Length == 0) // When delete whole content in the combo
                {
                    string temp = textElement.Value.GetText(false);
                    temp = temp.Replace("<span style=\"background-color:Yellow; font-weight:bold;\">", "");
                    temp = temp.Replace("</span>", "");
                    textElement.Value = new ParsedFormattedTextValue(temp);
                }
                else if (textElement.Value.GetText(true).Contains(SearchText)) // Highlight the text
                {
                    string temp = textElement.Value.GetText(false);
                    temp = temp.Replace("<span style=\"background-color:Yellow; font-weight:bold;\">", "");
                    temp = temp.Replace("</span>", "");
                    temp = temp.Replace(SearchText, "<span style=\"background-color:Yellow; font-weight:bold;\">" + SearchText + "</span>");
                    textElement.Value = new ParsedFormattedTextValue(temp);
                }
                else // Case when using direct mouse click at the dropdown items
                {
                    string temp = textElement.Value.GetText(false);
                    temp = temp.Replace("<span style=\"background-color:Yellow; font-weight:bold;\">", "");
                    temp = temp.Replace("</span>", "");
                    textElement.Value = new ParsedFormattedTextValue(temp);
                }
            }
            return false;
        }
    }
}
